<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: gg::EventDispatcher Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacegg.html">gg</a></li><li class="navelem"><a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="classgg_1_1EventDispatcher-members.html">List of all members</a>  </div>
  <div class="headertitle"><div class="title">gg::EventDispatcher Class Reference</div></div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="Event_8hpp_source.html">Event.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-methods" name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a87ff25ad98e9fa481e6f64247d7aba4d"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classgg_1_1EventDispatcher.html#a87ff25ad98e9fa481e6f64247d7aba4d">EventDispatcher</a> (<a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;&amp;)=delete</td></tr>
<tr class="separator:a87ff25ad98e9fa481e6f64247d7aba4d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b583685f6d4dd8685bab4f7c5e3e279"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classgg_1_1EventDispatcher.html#a7b583685f6d4dd8685bab4f7c5e3e279">EventDispatcher</a> (const <a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;)=delete</td></tr>
<tr class="separator:a7b583685f6d4dd8685bab4f7c5e3e279"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad509264c69cbbbace55964f563d7d0d8"><td class="memItemLeft" align="right" valign="top">auto&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classgg_1_1EventDispatcher.html#ad509264c69cbbbace55964f563d7d0d8">operator=</a> (const <a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;) -&gt; <a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;=delete</td></tr>
<tr class="separator:ad509264c69cbbbace55964f563d7d0d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b6b1302a26315587a73a74ac8395c71"><td class="memItemLeft" align="right" valign="top">auto&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classgg_1_1EventDispatcher.html#a7b6b1302a26315587a73a74ac8395c71">operator=</a> (<a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;&amp;) -&gt; <a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;=delete</td></tr>
<tr class="separator:a7b6b1302a26315587a73a74ac8395c71"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-static-methods" name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ab0f8028199ca3b02d37f642ac24e6e53"><td class="memItemLeft" align="right" valign="top">static auto&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classgg_1_1EventDispatcher.html#ab0f8028199ca3b02d37f642ac24e6e53">GetInstance</a> () -&gt; <a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;</td></tr>
<tr class="separator:ab0f8028199ca3b02d37f642ac24e6e53"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a25898f3f671cc2fcdb9ac2e5b5fd1a3e"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classgg_1_1EventDispatcher.html#a25898f3f671cc2fcdb9ac2e5b5fd1a3e">Subscribe</a> (<a class="el" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a> *s, const <a class="el" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">EventType</a> e)</td></tr>
<tr class="separator:a25898f3f671cc2fcdb9ac2e5b5fd1a3e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa2ac8a84c686abe1e1d1319e82221ed7"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classgg_1_1EventDispatcher.html#aa2ac8a84c686abe1e1d1319e82221ed7">Unsubscribe</a> (<a class="el" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a> *s, const <a class="el" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">EventType</a> e)</td></tr>
<tr class="separator:aa2ac8a84c686abe1e1d1319e82221ed7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d3c833a67f1cde56f6f4ca2ed0a4fbd"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classgg_1_1EventDispatcher.html#a7d3c833a67f1cde56f6f4ca2ed0a4fbd">RemoveSubscriber</a> (<a class="el" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a> *s)</td></tr>
<tr class="separator:a7d3c833a67f1cde56f6f4ca2ed0a4fbd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac0c4379683c748e569a9fa6be55bab55"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classgg_1_1EventDispatcher.html#ac0c4379683c748e569a9fa6be55bab55">NotifySubscribers</a> (<a class="el" href="classgg_1_1IEvent.html">IEvent</a> *e)</td></tr>
<tr class="separator:ac0c4379683c748e569a9fa6be55bab55"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7ad81d66b2f595f42de4e7841ef11044"><td class="memItemLeft" align="right" valign="top">static auto&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classgg_1_1EventDispatcher.html#a7ad81d66b2f595f42de4e7841ef11044">NumberOfSubscribers</a> () -&gt; int</td></tr>
<tr class="separator:a7ad81d66b2f595f42de4e7841ef11044"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="friends" name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:ab3245f7372c0d5384580f75c0ce2301b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classgg_1_1EventDispatcher.html#ab3245f7372c0d5384580f75c0ce2301b">CheckSubscriberExistence</a> (<a class="el" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a> *e)</td></tr>
<tr class="separator:ab3245f7372c0d5384580f75c0ce2301b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a87ff25ad98e9fa481e6f64247d7aba4d" name="a87ff25ad98e9fa481e6f64247d7aba4d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a87ff25ad98e9fa481e6f64247d7aba4d">&#9670;&nbsp;</a></span>EventDispatcher() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">gg::EventDispatcher::EventDispatcher </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;&amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">delete</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a7b583685f6d4dd8685bab4f7c5e3e279" name="a7b583685f6d4dd8685bab4f7c5e3e279"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7b583685f6d4dd8685bab4f7c5e3e279">&#9670;&nbsp;</a></span>EventDispatcher() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">gg::EventDispatcher::EventDispatcher </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">delete</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ab0f8028199ca3b02d37f642ac24e6e53" name="ab0f8028199ca3b02d37f642ac24e6e53"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab0f8028199ca3b02d37f642ac24e6e53">&#9670;&nbsp;</a></span>GetInstance()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static auto gg::EventDispatcher::GetInstance </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> -&gt; <a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;
    </td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ac0c4379683c748e569a9fa6be55bab55" name="ac0c4379683c748e569a9fa6be55bab55"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac0c4379683c748e569a9fa6be55bab55">&#9670;&nbsp;</a></span>NotifySubscribers()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void gg::EventDispatcher::NotifySubscribers </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classgg_1_1IEvent.html">IEvent</a> *&#160;</td>
          <td class="paramname"><em>e</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a7ad81d66b2f595f42de4e7841ef11044" name="a7ad81d66b2f595f42de4e7841ef11044"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7ad81d66b2f595f42de4e7841ef11044">&#9670;&nbsp;</a></span>NumberOfSubscribers()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static auto gg::EventDispatcher::NumberOfSubscribers </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> -&gt;  int</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ad509264c69cbbbace55964f563d7d0d8" name="ad509264c69cbbbace55964f563d7d0d8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad509264c69cbbbace55964f563d7d0d8">&#9670;&nbsp;</a></span>operator=() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">auto gg::EventDispatcher::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> -&gt;  <a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;=delete</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">delete</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a7b6b1302a26315587a73a74ac8395c71" name="a7b6b1302a26315587a73a74ac8395c71"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7b6b1302a26315587a73a74ac8395c71">&#9670;&nbsp;</a></span>operator=() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">auto gg::EventDispatcher::operator= </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;&amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> -&gt;  <a class="el" href="classgg_1_1EventDispatcher.html">EventDispatcher</a> &amp;=delete</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">delete</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a7d3c833a67f1cde56f6f4ca2ed0a4fbd" name="a7d3c833a67f1cde56f6f4ca2ed0a4fbd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7d3c833a67f1cde56f6f4ca2ed0a4fbd">&#9670;&nbsp;</a></span>RemoveSubscriber()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void gg::EventDispatcher::RemoveSubscriber </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a> *&#160;</td>
          <td class="paramname"><em>s</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a25898f3f671cc2fcdb9ac2e5b5fd1a3e" name="a25898f3f671cc2fcdb9ac2e5b5fd1a3e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a25898f3f671cc2fcdb9ac2e5b5fd1a3e">&#9670;&nbsp;</a></span>Subscribe()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void gg::EventDispatcher::Subscribe </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a> *&#160;</td>
          <td class="paramname"><em>s</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">EventType</a>&#160;</td>
          <td class="paramname"><em>e</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="aa2ac8a84c686abe1e1d1319e82221ed7" name="aa2ac8a84c686abe1e1d1319e82221ed7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa2ac8a84c686abe1e1d1319e82221ed7">&#9670;&nbsp;</a></span>Unsubscribe()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void gg::EventDispatcher::Unsubscribe </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a> *&#160;</td>
          <td class="paramname"><em>s</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">EventType</a>&#160;</td>
          <td class="paramname"><em>e</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a id="ab3245f7372c0d5384580f75c0ce2301b" name="ab3245f7372c0d5384580f75c0ce2301b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab3245f7372c0d5384580f75c0ce2301b">&#9670;&nbsp;</a></span>CheckSubscriberExistence</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool CheckSubscriberExistence </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a> *&#160;</td>
          <td class="paramname"><em>e</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>include/core/<a class="el" href="Event_8hpp_source.html">Event.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
